//
//  ViewController.swift
//  AmpOctoshapeSample
//
//  Created by Lopez Valenciano, Miguel on 3/31/16.
//  Copyright © 2016 Akamai. All rights reserved.
//

import UIKit
import AmpCore
import AmpOctoshape

class ViewController: UIViewController, PlayerEventObserver {
    
    @IBOutlet weak var playerView: UIView!
    
    var ampPlayer: AmpPlayer!
    var ampPlayerManager: AmpPlayerManager!
    var ampOctoshapeManager: AmpOctoshapeManager!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.createPlayer()
    }
    
    func createPlayer() {
        if self.ampPlayerManager == nil {
            let octoUrl = "octoshape://streams.octoshape.net/demo/live/nascar/abr"
            
            // Instantiate player
            let rect = CGRectMake(10, 40, 300, 180)
            
            self.ampPlayer = AmpPlayer()
            self.ampPlayer.autoplay = true
            self.ampPlayerManager = AmpPlayerManager(ampPlayer: ampPlayer, parentView: self.view, playerFrame: rect)
            
            // Register
            self.ampPlayerManager?.ampPlayer?.registerObserver(self)
            
            let times = [2.0, 4.0, 6.0, 8.0]
            _ = CuepointManager(ampPlayer: self.ampPlayer, observer: self, times: times)
            
            // Instantiate the Octoshape Manager before we handle the URL
            self.ampOctoshapeManager = AmpOctoshapeManager(ampPlayer: self.ampPlayer, enableLogs: true, container: self.view)
            
            self.ampPlayer.handleUrl(octoUrl)
        }
    }
    
    @IBAction func create(sender: UIButton) {
        self.createPlayer()
    }
    
    @IBAction func destroy(sender: UIButton) {
        self.ampPlayer.stop()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: PlayerEventObserver
    
    func onAmpBufferingStateChanged(ampPlayer: AmpPlayer) {
        //        print("onBufferingStateChanged")
        if (ampPlayer.bufferingState == BufferingState.Ready) {
            print("BufferingState.Ready")
//            ampPlayer.play()
        }
    }
}
